package kernel.service;

import kernel.ps.ProcessManager;
import kernel.ps.ProcessHandle;
import kernel.binstore.BinStore;

using tink.CoreApi;

class Service {
    private final binName:String;
    private final name:String;
    private final args:Array<String>;
    private var pid:PID;

    @:allow(kernel.service.ServiceManager)
    private function new(binName: String,name: String,?args: Array<String> ) {
        this.binName = binName;
        this.name = name;
        this.args = args ?? [];
    }

    public function start() {
        var bin = BinStore.instance.getBinByAlias(this.binName);

        if (bin == null){
            throw new Error('Bin ${this.binName} not found');
        }
        
        var ps = Type.createInstance(bin.c,this.args);

        this.pid = ProcessManager.run(ps,{});
    }

    public function stop() {
        ProcessManager.kill(this.pid);
    }

}
